(set-info :smt-lib-version 2.6)
(set-logic UFIDL)
(set-info :source | An Optimal Algorithm for Mutual Exclusion in Computer Networks. Glenn Ricart and Ashok K. Agrawala. Communications of the ACM Vol.: 24 Number: 1. This is a benchmark of the haRVey theorem prover. It was translated to SMT-LIB by Leonardo  de Moura |)
(set-info :category "industrial")
(set-info :status unsat)
(declare-fun p () Int)
(declare-fun q () Int)
(declare-fun r () Int)
(declare-fun s () Int)
(declare-fun s0 (Int) Bool)
(declare-fun s1 (Int) Bool)
(declare-fun s2 (Int) Bool)
(declare-fun s3 (Int) Bool)
(declare-fun s4 (Int) Bool)
(declare-fun s5 (Int) Bool)
(declare-fun s6 (Int) Bool)
(declare-fun rcs1 (Int) Bool)
(declare-fun rcs2 (Int) Bool)
(declare-fun x (Int Int) Bool)
(declare-fun ro (Int Int) Bool)
(declare-fun rd (Int Int) Bool)
(declare-fun sn (Int) Int)
(declare-fun time () Int)
(assert (not (=> (and (forall ((?p Int)) (forall ((?q Int)) (=> (or (s0 ?p) (s5 ?p)) (not (x ?p ?q))))) (forall ((?p Int)) (= (or (s0 ?p) (s6 ?p)) (not (rcs2 ?p)))) (forall ((?p Int)) (< (sn ?p) time)) (forall ((?p Int)) (forall ((?q Int)) (=> (not (= ?p ?q)) (not (= (sn ?p) (sn ?q)))))) (forall ((?p Int)) (forall ((?q Int)) (=> (and (not (= ?p ?q)) (or (and (s4 ?p) (x ?p ?q)) (s5 ?p)) (rcs2 ?q)) (< (sn ?p) (sn ?q))))) (forall ((?p Int)) (forall ((?q Int)) (=> (and (not (= ?p ?q)) (rd ?q ?p)) (ro ?p ?q)))) (forall ((?p Int)) (forall ((?q Int)) (let ((?v_0 (x ?p ?q))) (=> (not (= ?p ?q)) (= (not (or (and (s2 ?p) ?v_0) (and (s3 ?p) (not ?v_0)))) (=> (ro ?p ?q) (rd ?q ?p))))))) (forall ((?p Int)) (forall ((?q Int)) (let ((?v_1 (x ?q ?p))) (let ((?v_2 (or (and (s3 ?q) ?v_1) (and (s4 ?q) (not ?v_1))))) (=> (not (= ?p ?q)) (or (and (s6 ?p) (not (x ?p ?q)) ?v_2) (= (rd ?p ?q) (and ?v_2 (rcs2 ?p) (< (sn ?p) (sn ?q)))))))))) (forall ((?p Int)) (=> (s0 ?p) (not (or (s2 ?p) (s3 ?p) (s4 ?p) (s5 ?p) (s6 ?p))))) (forall ((?p Int)) (=> (s2 ?p) (not (or (s3 ?p) (s4 ?p) (s5 ?p) (s6 ?p))))) (forall ((?p Int)) (=> (s3 ?p) (not (or (s4 ?p) (s5 ?p) (s6 ?p))))) (forall ((?p Int)) (=> (s4 ?p) (not (or (s5 ?p) (s6 ?p))))) (forall ((?p Int)) (=> (s5 ?p) (not (s6 ?p)))) (forall ((?q Int)) (let ((?v_3 (not (= ?q p)))) (=> (s0 ?q) (not (or (s2 ?q) (s3 ?q) (s4 ?q) (and ?v_3 (=> ?v_3 (s5 ?q))) (=> ?v_3 (s6 ?q))))))) (forall ((?q Int)) (let ((?v_4 (not (= ?q p)))) (=> (s2 ?q) (not (or (s3 ?q) (s4 ?q) (and ?v_4 (=> ?v_4 (s5 ?q))) (=> ?v_4 (s6 ?q))))))) (forall ((?q Int)) (let ((?v_5 (not (= ?q p)))) (=> (s3 ?q) (not (or (s4 ?q) (and ?v_5 (=> ?v_5 (s5 ?q))) (=> ?v_5 (s6 ?q))))))) (forall ((?q Int)) (let ((?v_6 (not (= ?q p)))) (=> (s4 ?q) (not (or (and ?v_6 (=> ?v_6 (s5 ?q))) (=> ?v_6 (s6 ?q))))))) (forall ((?q Int)) (let ((?v_7 (not (= ?q p)))) (=> (and ?v_7 (=> ?v_7 (s5 ?q))) (not (=> ?v_7 (s6 ?q)))))) (s5 p) (not (rcs1 p))) (and (forall ((?r Int)) (forall ((?q Int)) (let ((?v_8 (not (= ?r p)))) (=> (or (s0 ?r) (and ?v_8 (=> ?v_8 (s5 ?r)))) (not (x ?r ?q)))))) (forall ((?r Int)) (let ((?v_9 (not (= ?r p)))) (= (or (s0 ?r) (=> ?v_9 (s6 ?r))) (not (and ?v_9 (=> ?v_9 (rcs2 ?r))))))) (forall ((?r Int)) (< (sn ?r) time)) (forall ((?r Int)) (forall ((?q Int)) (=> (not (= ?r ?q)) (not (= (sn ?r) (sn ?q)))))) (forall ((?r Int)) (forall ((?q Int)) (let ((?v_10 (not (= ?r p))) (?v_11 (not (= ?q p)))) (=> (and (not (= ?r ?q)) (or (and (s4 ?r) (x ?r ?q)) (and ?v_10 (=> ?v_10 (s5 ?r)))) ?v_11 (=> ?v_11 (rcs2 ?q))) (< (sn ?r) (sn ?q)))))) (forall ((?r Int)) (forall ((?q Int)) (=> (and (not (= ?r ?q)) (rd ?q ?r)) (ro ?r ?q)))) (forall ((?r Int)) (forall ((?q Int)) (let ((?v_12 (x ?r ?q))) (=> (not (= ?r ?q)) (= (not (or (and (s2 ?r) ?v_12) (and (s3 ?r) (not ?v_12)))) (=> (ro ?r ?q) (rd ?q ?r))))))) (forall ((?r Int)) (forall ((?q Int)) (let ((?v_15 (not (= ?r p))) (?v_13 (x ?q ?r))) (let ((?v_14 (or (and (s3 ?q) ?v_13) (and (s4 ?q) (not ?v_13))))) (=> (not (= ?r ?q)) (or (and (=> ?v_15 (s6 ?r)) (not (x ?r ?q)) ?v_14) (= (rd ?r ?q) (and ?v_14 ?v_15 (=> ?v_15 (rcs2 ?r)) (< (sn ?r) (sn ?q))))))))))))))
(check-sat)
(exit)
